# Lab 2: Test First

These are the instructions for Lab2, which teaches basic applications of the Test First principle, using JUnit. See also a separate short [introduction to the JUnit framework](https://coursegit.cs.lth.se/edaf45/resources/junit-intro).

These instructions are written in LaTeX, and are published on the course website. You can also clone this project and compile the document yourself, or [download the latest version](https://coursegit.cs.lth.se/edaf45/resources/lab2-test-first/-/jobs/artifacts/latest-release/file/lab2-test-first.pdf?job=build_latex).

We value your input and welcome contributions to improve these instructions! Whether you find errors, have suggestions for clarifications, or want to add something valuable, please consider contributing. You can find more information on how to do so in the "Contributing" section below.

## Prerequisite

To properly compile and build the document, make sure you have LaTeX installed (e.g. [TeX Live](https://tug.org/texlive/)).

### Clone the Repository

To get started, clone this repository to your local machine:

```bash
git clone git@coursegit.cs.lth.se:edaf45/resources/lab2-test-first.git
cd lab2-test-first
```

### Building the LaTeX Document

Inside the repository, you'll find the lab instructions in `lab2-test-first.tex`, that you can build. Use the following command to build the PDF:

```bash
xelatex lab2-test-first.tex
```

(It might work in other latex implementations, e.g. pdflatex, I've only tried xelatex.)

### If using VS Code

_(I use the LaTeX Workshop plugin, so that is what these instructions are based on.)_

VS Code defines 'recipes' for how to build LaTeX. Open settings and search for 'recipe'. Others might work, but I use "**latexmk (xelatex)**".

## Contributing

We welcome contributions to improve these instructions. If you find errors, want to clarify content, or have suggestions, please consider contributing by submitting issues or merge requests.

### Submitting issues

To submit an issue, click the **Isues** menu option on the left-side edge, then **New issue**. Give a descriptive title and description, and possibly a suggested change or solution. Assign it to _Mattias Nordahl_, and hit **Create issue**.

### Submitting merge requests

To submit merge requests, please follow these steps:

Fork this repository on this GitLab server (coursegit.cs.lth.se). Create a new branch for your changes:

```bash
git checkout -b your-feature-or-fix
```

Make your changes and commit them:

```bash
git commit -am "Add your commit message here"
```

Push your changes to your forked repository:

```bash
git push origin your-feature-or-fix
```

On the coursegit website for you fork, create a merge request (MR) from your forked repository to this main repository. Provide a descriptive title and explanation of your changes in the MR. We will review your MR and merge it if it aligns with what we're aiming for with the lab. Thank you for contributing and for helping to make the course even better!
