#!/bin/bash

# Check if a tag name was provided
if [ "$#" -ne 1 ]; then
    echo "Usage: $0 <tag_name>"
    exit 1
fi

tag_name=$1

# Move the 'latest-release' tag to the current commit (delete the tag on the remote and then push the local one)
git push origin :refs/tags/latest-release
git tag -f latest-release

# Push the 'latest-release' tag
git push origin refs/tags/latest-release


# Tag the current commit with the provided tag name
git tag $tag_name

# Push the new tag
git push origin $tag_name
